
#include "hal/hal.h"
#include "node.h"
#include "gfx/layout.h"


#include "example.h"

#include "gfx/screen.h"
#include "gfx/canvas.h"
#include "buttons.h"

#ifdef LINUX
#include <SDL2/SDL.h>
#include <stdio.h>
#include <iostream>


extern SDL_Window* window;
extern SDL_Event event;
extern SDL_Renderer *renderer;

#endif


screen s(128,32);
layout l(s);
menu* root;

int main() {

	root = new menu("",
					new menu("foo",
                             new menu("baz",
                                      new fooValue("I", 5),
                                      new fooValue("II", 5),
                                      new fooValue("III", 5),
                                      new fooValue("IIII", 5)
                             ),
                             new menu("peng",
                                      new fooValue("o", 5),
                                      new fooValue("oo", 5),
                                      new fooValue("o o", 5)
                             ),
							 new menu("x",
									  new fooValue("x x", 5),
									  new fooValue("xxx", 5)
							 ),
							 new menu("y",
									  new fooValue("y y", 5),
									  new fooValue("yyy", 5)
							 )
			),
					new menu("a",
							 new blubValue("a a", 5),
							 new blubValue("aa", 5),
							 new blubValue("aaa", 5)
					),
					new menu("b",
							 new blubValue("b b", 5),
							 new blubValue("bb", 5),
							 new blubValue("bbb", 5)
					),
					new menu("c",
							 new blubValue("c c", 5),
							 new blubValue("cc", 5),
							 new blubValue("ccc", 5)
					)
	);

	hal_render();
	return 0;
}

void render(){
	l.apply(root);
	input.poll();
	l.render();
}

void buttons::onPush(int id, bool state) {
	if (state) {
		node *c;
		node *p;
		switch (id) {
			case I_DOWN:
				c = l.cursor;
				p = c->getParent();
				if ((c = c->getNext()) || p && (c = p->getChild())) {
					p->setCursor(c);
					l.cursor = c;
				}
				break;
			case I_UP:
				break;
			case I_RIGHT:
				c = l.cursor;
				if (c = c->getCursor()) {
					l.cursor = c;
				}
				break;
			case I_LEFT:
				c = l.cursor;
				if (c = c->getParent()) {
					l.cursor = c;
				}
				break;
		}
	}
}